unit UfrmEnconfig;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dxExEdtr, DB, dxCntner, dxTL, dxDBCtrl, dxDBGrid, dxmdaset,
  RzButton, ExtCtrls, RzPanel, Menus, dxDBTLCl, dxGrClms,
  SyncObjs, UGlobals, StdCtrls, RzLabel, Mask, RzEdit, RzCmboBx, RzRadChk,
  RzSpnEdt, dxGrClEx, HHComp;

type
  TfrmEnconfig = class(TForm)
    RzPanel1: TRzPanel;
    dxMemData_Enconfig: TdxMemData;
    dxDBGrid_Enconfig: TdxDBGrid;
    Col_EncNumber: TdxDBGridColumn;
    Col_EncDescription: TdxDBGridColumn;
    Col_Active: TdxDBGridCheckColumn;
    Col_Step: TdxDBGridColumn;
    Col_Max: TdxDBGridColumn;
    Col_Min: TdxDBGridColumn;
    Col_ReadBytes: TdxDBGridColumn;
    Col_SetBytes: TdxDBGridColumn;
    Col_AnswerBytes: TdxDBGridColumn;
    Col_ReadMask: TdxDBGridColumn;
    Col_SetMask: TdxDBGridColumn;
    Col_AnswerMask: TdxDBGridColumn;
    Col_Units: TdxDBGridColumn;
    dxMemData_EnconfigACTIVE: TBooleanField;
    dxMemData_EnconfigNumber: TSmallintField;
    dxMemData_EnconfigStep: TSmallintField;
    dxMemData_EnconfigMin: TIntegerField;
    dxMemData_EnconfigMax: TIntegerField;
    dxMemData_EnconfigReadBytes: TSmallintField;
    dxMemData_EnconfigSetBytes: TSmallintField;
    dxMemData_EnconfigAnswerBytes: TSmallintField;
    dxMemData_EnconfigReadMask: TStringField;
    dxMemData_EnconfigSetMask: TStringField;
    dxMemData_EnconfigAnswerMask: TStringField;
    dxMemData_EnconfigUnits: TStringField;
    dxMemData_EnconfigNumberError: TIntegerField;
    DS_Enconfig: TDataSource;
    Col_NumberError: TdxDBGridColumn;
    RzBitBtn_ReadEnc: TRzBitBtn;
    RzBitBtn_SetEncoders: TRzBitBtn;
    RzBitBtn_WriteToFile: TRzBitBtn;
    RzBitBtn_ReadFromFile: TRzBitBtn;
    RzEdit_Title: TRzEdit;
    RzLabel1: TRzLabel;
    SaveDialog_Enconfig: TSaveDialog;
    OpenDialog_Enconfig: TOpenDialog;
    RzCombo_BaudRate: TRzComboBox;
    RzLabel2: TRzLabel;
    RzCombo_StopBits: TRzComboBox;
    RzLabel3: TRzLabel;
    RzCombo_Parity: TRzComboBox;
    RzLabel4: TRzLabel;
    RzCombo_CharBits: TRzComboBox;
    RzLabel5: TRzLabel;
    dxMemData_EnconfigDescription: TStringField;
    dxMemData_EnconfigDisplayMult: TSmallintField;
    dxMemData_EnconfigDisplayDiv: TSmallintField;
    Col_Mult: TdxDBGridColumn;
    Col_Div: TdxDBGridColumn;
    Col_DecPlaces: TdxDBGridColumn;
    RzChBox_DisplayPanel: TRzCheckBox;
    Col_Lookup: TdxDBGridCheckColumn;
    dxMemData_EnconfigLookup: TBooleanField;
    RzSpinEdit_Contrast: TRzSpinEdit;
    RzLabel6: TRzLabel;
    dxMemData_EnconfigDataDigits: TSmallintField;
    Col_RigAddress: TdxDBGridColumn;
    Col_EncatAddress: TdxDBGridColumn;
    Col_DataDigits: TdxDBGridColumn;
    Col_Command: TdxDBGridColumn;
    Col_SubComHex: TdxDBGridColumn;
    Col_LevelData: TdxDBGridColumn;
    dxMemData_EnconfigLevelData: TSmallintField;
    Col_SubComDecimal: TdxDBGridColumn;
    dxMemData_EnconfigSubComDecimal: TIntegerField;
    RzRB_RS232: TRzRadioButton;
    RzRB_CIV: TRzRadioButton;
    dxMemData_EnconfigDecPlaces: TSmallintField;
    Col_ReadSend: TdxDBGridPickColumn;
    Col_SubComType: TdxDBGridPickColumn;
    Col_EncMode: TdxDBGridPickColumn;
    dxMemData_EnconfigSubComType: TStringField;
    dxMemData_EnconfigEncmode: TStringField;
    dxMemData_EnconfigReadSend: TStringField;
    dxMemData_EnconfigSubComHex: TStringField;
    dxMemData_EnconfigEncatAddress: TStringField;
    dxMemData_EnconfigCommand: TStringField;
    dxMemData_EnconfigRigAddress: TStringField;
    RzLabel_HexGreen: TRzLabel;
    RzBitBtn_Help: TRzBitBtn;
    HtmlHelp: TEmbeddedHtmlHelp;

    procedure dxDBGrid_EnconfigCustomDrawCell(Sender: TObject;
      ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
      AColumn: TdxTreeListColumn; ASelected, AFocused,
      ANewItemRow: Boolean; var AText: String; var AColor: TColor;
      AFont: TFont; var AAlignment: TAlignment; var ADone: Boolean);
    procedure RzBitBtn_ReadEncClick(Sender: TObject);
    procedure RzBitBtn_SetEncodersClick(Sender: TObject);
    procedure RzBitBtn_WriteToFileClick(Sender: TObject);
    procedure RzBitBtn_ReadFromFileClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Menu_SaveClick(Sender: TObject);
    procedure Menu_LoadClick(Sender: TObject);
    procedure RzRB_RS232Click(Sender: TObject);
    procedure RzRB_CIVClick(Sender: TObject);
    procedure RzBitBtn_HelpClick(Sender: TObject);
  private
    block: array[0..128] of byte;
    EnconfigDelayEvent: TEvent;
    EnconfigX: TEnconfig;
    function GetMemData: boolean;
    function DoSetEncatEncoders: boolean;
    function DoReadEncatEncoders: boolean;
    procedure DisplayEncatOptions;
    procedure GetEncatOptions;
    procedure SetGrid(civ: boolean);
    function GetSubComTypeIndex(s: string): byte;
    function GetReadSendIndex(s: string): byte;
    function GetEncModeIndex(s: string): byte;

  public
    IcomCIV: bool;
    ActiveFieldIndex: integer;
    NumberFieldIndex: integer;
    StepFieldIndex: integer;
    MinFieldIndex: integer;
    MaxFieldIndex: integer;
    ReadBytesFieldIndex: integer;
    SetBytesFieldIndex: integer;
    AnswerBytesFieldIndex: integer;
    ReadMaskFieldIndex: integer;
    SetMaskFieldIndex: integer;
    AnswerMaskFieldIndex: integer;
    DescriptionFieldIndex: integer;
    UnitsFieldIndex: integer;
    NumberErrorFieldIndex: integer;
    DisplayMultFieldIndex: integer;
    DisplayDivFieldIndex: integer;
    DecPlacesFieldIndex: integer;
    LookupFieldIndex: integer;

    RigaddressFieldIndex: integer;
    EnCatAddressFieldIndex: integer;
    SubComTypeFieldIndex: integer;
    ReadSendFieldIndex: integer;
    EncModeFieldIndex: integer;
    DataDigitsFieldIndex: integer;
    CommandFieldIndex: integer;
    SubComHexFieldIndex: integer;
    LevelDataFieldIndex: integer;
    SubComDecimalFieldIndex: integer;

    procedure Initialise;
    procedure SetMemData;
    procedure SetEncatEncoders;
    procedure ReadEncatEncoders;
  end;



const

SubComTypeStrings: array[0..4] of string[13] =
( 'none',
  'Single HEX',
  'HEX + LEVEL',
  'BCD 4 digit',
  'BCD 6 digit'
);


ReadSendStrings: array[0..1] of string[12] =
( 'READ & SEND',
  'SEND ONLY'
);

EncModeStrings: array[0..3] of string[12] =
( 'no data',
  'ON / OFF',
  'UP / DOWN',
  'TOGGLE'
);





var
  frmEnconfig: TfrmEnconfig;

implementation

{$R *.dfm}

uses D2XXUnit, UUsb, UfrmMain, UIniData;

procedure TfrmEnconfig.Initialise;
begin
  EnconfigDelayEvent := TEvent.Create(0, true, false, 'xCAT USB delay event');
  ActiveFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Active').Index;
  NumberFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Number').Index;
  StepFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Step').Index;
  MinFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Min').Index;
  MaxFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Max').Index;
  ReadBytesFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('ReadBytes').Index;
  SetBytesFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('SetBytes').Index;
  AnswerBytesFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('AnswerBytes').Index;
  ReadMaskFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('ReadMask').Index;
  SetMaskFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('SetMask').Index;
  AnswerMaskFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('AnswerMask').Index;
  DescriptionFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Description').Index;
  UnitsFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Units').Index;
  NumberErrorFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('NumberError').Index;
  DisplayMultFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('DisplayMult').Index;
  DisplayDivFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('DisplayDiv').Index;
  DecPlacesFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Decplaces').Index;
  LookupFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Lookup').Index;
  /////
  RigaddressFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('RigAddress').Index;
  EnCatAddressFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('EnCatAddress').Index;
  SubComTypeFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('SubComType').Index;
  ReadSendFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('ReadSend').Index;
  EncModeFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('EncMode').Index;
  DataDigitsFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('DataDigits').Index;
  CommandFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('Command').Index;
  SubComHexFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('SubComHex').Index;
  LevelDataFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('LevelData').Index;
  SubComDecimalFieldIndex := dxDBGrid_Enconfig.ColumnByFieldName('SubComDecimal').Index;
  IcomCIV := false;
  Fillchar(g_Encoders, sizeof(g_Encoders),0);
  g_Encoders[8].ecCharBits := 1;
  g_Encoders[8].ecBaudRate := 3;
  DisplayEncatOptions;
  SetMemData;
end;


 {
TEnconfig = record
  ecActive: byte;
  ecNumber: byte;
  ecStep: word;
  ecMin: longint;
  ecMax: longint;
  ecReadBytes: byte;
  ecSetBytes: byte;
  ecAnswerBytes: byte;
  ecReadMask: array[0..15] of char;
  ecSetMask: array[0..27] of char;
  ecAnswerMask: array[0..27] of char;
  ecDescription: array[0..23] of char;
  ecUnits: array[0..6] of char;
  // BaudRate, StopBits, Parity, CharBits set only in record for Encoder zero 
  ecBaudRate: byte;   // index of combo
  ecStopBits: byte;  // index of combo
  ecParity: byte;     // index of combo
  ecCharBits: byte;    // index of combo
  ecSpare: array[0..5] of byte;
end;
}


function TfrmEnconfig.GetSubComTypeIndex(s: string): byte;
var
  i: byte;
begin
  for i := 0 to 4 do
  begin
    if s = SubComTypeStrings[i] then
    begin
      result := i;
      exit;
    end;
  end;
  result := 255;
end;




function TfrmEnconfig.GetReadSendIndex(s: string): byte;
var
  i: byte;
begin
  for i := 0 to 1 do
  begin
    if s = ReadSendStrings[i] then
    begin
      result := i;
      exit;
    end;
  end;
  result := 255;
end;



function TfrmEnconfig.GetEncModeIndex(s: string): byte;
var
  i: byte;
begin
  for i := 0 to 3 do
  begin
    if s = EncModeStrings[i] then
    begin
      result := i;
      exit;
    end;
  end;
  result := 255;
end;


procedure TfrmEnconfig.SetGrid(civ: boolean);
var
  clCell: TColor;
begin
  IcomCIV := civ;
  RzLabel_HexGreen.Visible := civ;
  with dxDBGrid_Enconfig do
  begin
    HeaderPanelMaxRowCount := 2;
    HeaderPanelRowCOunt := 2;
  end;
  Col_RigAddress.Visible := civ;
  Col_EncatAddress.Visible := civ;
  Col_SubComType.Visible := civ;
  Col_ReadSend.Visible := civ;
  Col_EncMode.Visible := civ;
  Col_DataDigits.Visible := civ;
  Col_Command.Visible := civ;
  Col_SubComHex.Visible := civ;
  Col_LevelData.Visible := civ;
  Col_SubComDecimal.Visible := civ;
  Col_ReadMask.Visible := not civ;
  Col_AnswerMask.Visible := not civ;
  Col_SetMask.Visible := not civ;
  ///////////////////////////
  Col_ReadBytes.DisableEditor :=  civ;
  Col_SetBytes.DisableEditor := civ;
  Col_AnswerBytes.DisableEditor := civ;
  Col_ReadBytes.DisableCaption :=  civ;
  Col_SetBytes.DisableCaption := civ;
  Col_AnswerBytes.DisableCaption := civ;



  if civ then clCell := clWindow else clCell := clWindowText;
  Col_ReadBytes.Font.Color := clCell;
  Col_SetBytes.Font.Color := clCell;
  Col_AnswerBytes.Font.Color := clCell;


  if civ then
  begin
    Col_RigAddress.RowIndex := 1;
    Col_EncatAddress.RowIndex := 1;
    Col_SubComType.RowIndex := 1;
    Col_ReadSend.RowIndex := 1;
    Col_EncMode.RowIndex := 1;
    Col_DataDigits.RowIndex := 1;
    Col_DataDigits.RowIndex := 1;
    Col_Command.RowIndex := 1;
    Col_SubComHex.RowIndex := 1;
    Col_LevelData.RowIndex := 1;
    Col_SubComDecimal.RowIndex := 1;

  end
  else begin
   // Col_ReadBytes.Visible := not civ;
   // Col_SetBytes.Visible := not civ;
   // Col_AnswerBytes.Visible := not civ;
    Col_ReadMask.RowIndex := 1;
    Col_AnswerMask.RowIndex := 1;
    Col_SetMask.RowIndex := 1;
  end;

end;


procedure TfrmEnconfig.DisplayEncatOptions;
begin
  with g_Encoders[8] do
  begin
    RzCombo_BaudRate.ItemIndex := ecBaudRate;
    RzCombo_StopBits.ItemIndex := ecStopBits;
    RzCombo_Parity.ItemIndex := ecParity;
    RzCombo_CharBits.ItemIndex := ecCharBits;
    RzEdit_Title.Text := ecSetMask;
    RzChBox_DisplayPanel.Checked := (ecDisplayPanel > 0);
    RzSpinEdit_Contrast.Value := ecContrast;
    if ecIcom > 0
    then Rzrb_CIV.Checked := true
    else RzRB_RS232.Checked := true;
  end;
  SetGrid(RzRB_CIV.Checked);
end;



procedure TfrmEnconfig.SetMemData;
var
  e: byte;
  s: string;
  number: byte;
begin
  dxMemData_Enconfig.Close;
  dxMemData_Enconfig.Open;
  for e := 0 to 7 do
  begin
    with g_Encoders[e], dxMemData_Enconfig do
    begin
      Append;
      FieldValues['Active'] := (ecActive > 0);
      if (ecActive > 0) AND (e <> ecNumber)
      then FieldValues['NumberError'] := 1
      else FieldValues['NumberError'] := 0;
      FieldValues['Number'] := e;
      FieldValues['Step'] := ecStep;
      FieldValues['Min'] := ecMin;
      FieldValues['Max'] := ecMax;
      s := ecDescription; FieldValues['Description'] := s;
      s := ecUnits; FieldValues['Units'] := s;
      FieldValues['DisplayMult'] := ecDisplayMult;
      FieldValues['DisplayDiv'] := ecDisplayDiv;
      FieldValues['DecPlaces'] := ecDecPlaces;
      FieldValues['Lookup'] := (ecLookup > 0);
      if IcomCIV then
      begin
        FieldValues['RigAddress'] := IntToHex(ecCIV.cvRigAddress,2);
        FieldValues['EncatAddress'] := IntToHex(ecCIV.cvEncatAddress,2);
        FieldValues['SubComType'] := SubComTypeStrings[byte(ecCIV.cvSubComType)];
        FieldValues['ReadSend'] := ReadSendStrings[byte(ecCIV.cvReadSend)];
        FieldValues['EncMode'] := EncModeStrings[byte(ecCIV.cvEncMode)];
        FieldValues['DataDigits'] := ecCIV.cvDataDigits;
        FieldValues['Command'] := IntToHex(ecCIV.cvCommand,2);
        FieldValues['SubComHex'] := IntToHex(ecCIV.cvSubComHex,2);
        FieldValues['Leveldata'] := ecCIV.cvLevelData;
        FieldValues['SubComDecimal'] := ecCIV.cvSubComDecimal;
      end
      else begin
        FieldValues['ReadBytes'] := ecReadBytes;
        FieldValues['SetBytes'] := ecSetBytes;
        FieldValues['AnswerBytes'] := ecAnswerBytes;
        s := ecReadMask; FieldValues['ReadMask'] := s;
        s := ecSetMask; FieldValues['SetMask'] := s;
        s := ecAnswerMask; FieldValues['AnswerMask'] := s;
      end;
      Post;
    end;
  end;
end;


function TfrmEnconfig.GetMemData: boolean;
var
  LWL, LWH: longword;
  e: byte;
  s: string;
  number: byte;
  bbool: boolean;
  index: byte;
  b: byte;
begin
  result := false;
  if not dxMemData_Enconfig.Active then exit;
  for e := 0 to 7 do
  begin
    with g_Encoders[e], dxMemData_Enconfig do
    begin
      if Locate('Number',e,[loCaseInsensitive]) then
      begin
        bbool := FieldByName('Active').AsBoolean;
        if bbool then ecActive := 1 else ecActive := 0;
        ecNumber := e;
        ecStep := FieldByName('Step').AsInteger;
        ecMin := FieldByName('Min').AsInteger;
        ecMax := FieldByName('Max').AsInteger;
        StringToCharray(FieldByName('Description').AsString, ecDescription);
        StringToCharray(FieldByName('Units').AsString, ecUnits);
        ecDisplayMult := FieldByName('DisplayMult').AsInteger;
        ecDisplayDiv := FieldByName('DisplayDiv').AsInteger;
        ecDecPlaces := FieldByName('DecPlaces').AsInteger;
        bbool := FieldByName('Lookup').AsBoolean;
        if bbool then ecLookup := 1 else ecLookup := 0;
        if IcomCIV then
        begin

          s := FieldByName('RigAddress').AsString;
          HexToInt(s, LWL, LWH);
          b := LWL;
          ecCIV.cvRigAddress := b;

          s := FieldByName('EncatAddress').AsString;
          HexToInt(s, LWL, LWH);
          b := LWL;
			    ecCIV.cvEncatAddress := b;

          s := FieldByName('SubComType').AsString;
          index := GetSubComTypeIndex(s);
          ecCIV.cvSubComType := TCIVsubcomtype(index);

          s := FieldByName('ReadSend').AsString;
          index := GetReadSendIndex(s);
          ecCIV.cvReadSend := TCIVreadsend(index);

          s := FieldByName('EncMode').AsString;
          index := GetEncModeIndex(s);
			    ecCIV.cvEncMode := TCIVencmode(index);

			    ecCIV.cvDataDigits := FieldByName('DataDigits').AsInteger;

          s := FieldByName('Command').AsString;
          HexToInt(s, LWL, LWH);
          b := LWL;
			    ecCIV.cvCommand := b;

          s := FieldByName('SubComHex').AsString;
          HexToInt(s, LWL, LWH);
          b := LWL;
			    ecCIV.cvSubComHex := b;

			    ecCIV.cvLevelData := FieldByName('LevelData').AsInteger;
			    ecCIV.cvSubComDecimal := FieldByName('SubComDecimal').AsInteger;
        end
        else begin
          ecReadBytes := FieldByName('ReadBytes').AsInteger;
          ecSetBytes := FieldByName('setBytes').AsInteger;
          ecAnswerBytes := FieldByName('AnswerBytes').AsInteger;
          StringToCharray(FieldByName('ReadMask').AsString, ecReadMask);
          StringToCharray(FieldByName('SetMask').AsString, ecSetMask);
          StringToCharray(FieldByName('AnswerMask').AsString, ecAnswerMask);
        end;
      end;
    end;
  end;
end;


//   'encoder 8' used for optionws
procedure TfrmEnconfig.GetEncatOptions;
var
  tf: byte;
begin
  with g_Encoders[8] do
  begin
    ecBaudRate := RzCombo_BaudRate.ItemIndex;
    ecStopBits := RzCOmbo_StopBits.ItemIndex;
    ecParity := RzCombo_Parity.ItemIndex;
    ecCharBits := RzCOmbo_CharBits.ItemIndex;
    // ecSetMask field used for title
    StringToCharray(RzEdit_Title.Text, ecSetMask);
    if RzChBox_DisplayPanel.Checked
       then ecDisplayPanel := 1 else ecDisplayPanel := 0;
    ecContrast := trunc(RzSpinEdit_Contrast.Value);
    if RzRB_CIV.Checked
      then ecIcom := 1
      else ecIcom := 0;
  end;
end;


procedure TfrmEnconfig.dxDBGrid_EnconfigCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: String; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
var
  x: byte;
  X1,Y1,X2,Y2: integer;
begin
  X1 := ARect.Left;
  Y1 := ARect.Top;
  X2 := ARect.Right;
  Y2 := ARect.Bottom;

  x := TdxDBGridNode(ANode).VariantValues[NumberErrorFieldindex];
  if x > 0 then
  begin
    AFont.Color := clRed;
    if AColumn.Index = NumberFieldIndex
        then AText := '* ' + AText + ' *'; 

  end;
end;


/////////////////////////////////////
procedure TfrmEnconfig.RzBitBtn_SetEncodersClick(Sender: TObject);
begin
  if frmMain.UsbAlive = false then
  begin
    MessageDlg('No EncoderCAT USB connection'#10#13' (See staus bar)',mtWarning, [mbOk],0);
    exit;
  end;
  GetEncatOptions;   // always before GetMemData   ... sets IcomCIV
  GetMemData;
  frmMain.USBstate[encset] := 'W';
end;

/////////////////////////////////////

procedure TfrmEnconfig.SetEncatEncoders;
var
  s: string;
  SetOk: boolean;
begin
  Screen.Cursor := crHourGlass;
  SetOK := DoSetEncatEncoders;
  Application.ProcessMessages;
  if SetOk then
  begin
    Screen.Cursor := crDefault;
    // job done ok
  end
  else begin
    Screen.Cursor := crDefault;
    s := 'EncoderCAT encoder setting FAILED';
    MessageDlg(s,mtWarning,[mbOk],0);
  end;
end;


function TfrmEnconfig.DoSetEncatEncoders;
var
  e: byte;
  chb: char;
begin
  result := false;
  for e := 0 to 8 do
  begin
  chb := chr(48 + e);
    Purge_USB_Device_In;
    if not Usb.usSendString('$$$ENC_S' + chb)
    then exit
    else begin
      move(g_Encoders[e], block, 128);
      if not Usb.usSendBlock(@block,128) then exit;
    end;
    EnconfigDelayEvent.ResetEvent;
    EnconfigDelayEvent.WaitFor(200);
  end;
  result := true;
end;
////////////////////////////////////////

procedure TfrmEnconfig.ReadEncatEncoders;
var
  s: string;
  ReadOk: boolean;
begin
  Screen.Cursor := crHourGlass;
  ReadOK := DoReadEncatEncoders;
  Application.ProcessMessages;
  if ReadOk then
  begin
    Screen.Cursor := crDefault;
    // use rthe data
  end
  else begin
    Screen.Cursor := crDefault;
    s := 'EncoderCAT encoder read FAILED';
    MessageDlg(s,mtWarning,[mbOk],0);
  end;
end;



function TfrmEnconfig.DoReadEncatEncoders: boolean;
var
  e: byte;
  chb: char;
begin
  result := false;
  for e := 0 to 8 do     // 'Ecoder 8' record used for options
  begin
    chb := chr(48 + e);
    Purge_USB_Device_In;
    if not Usb.usSendString('$$$ENC_R' + chb)
    then exit
    else begin
      EnconfigDelayEvent.ResetEvent;
      EnconfigDelayEvent.WaitFor(50);
      if not Usb.usReceiveBlock(@block,128) then exit;
      move(block, g_Encoders[e], 128);
      EnconfigDelayEvent.ResetEvent;
      EnconfigDelayEvent.WaitFor(20);
    end;
  end;
  DisplayEncatOptions;     // always BEFORE SetMemData
  SetMemData;
  result := true;
end;


procedure TfrmEnconfig.RzBitBtn_ReadEncClick(Sender: TObject);
begin
  if frmMain.UsbAlive = false then
  begin
    MessageDlg('No enCAT USB connection'#10#13' (See staus bar)',mtWarning, [mbOk],0);
    exit;
  end;
  frmMain.USBstate[encread] := 'W';
end;


procedure TfrmEnconfig.RzBitBtn_WriteToFileClick(Sender: TObject);
begin
  if SaveDialog_Enconfig.Execute then
  begin
    EnconfigIniFileName := SaveDialog_Enconfig.FileName;
    GetEncatOptions;      // always before GetMemData   ... sets IcomCIV
    GetMemData;
    WriteToEnconfigIniFile;
    g_RegIniData.IniEncodersIniFileName := EnconfigIniFileName;
    SaveRegIniFile;
  end;
end;

procedure TfrmEnconfig.RzBitBtn_ReadFromFileClick(Sender: TObject);
begin
  OpenDialog_Enconfig.FileName := g_RegIniData.IniEncodersIniFileName;
  if OpenDialog_Enconfig.Execute then
   begin
    EnconfigIniFileName := OpenDialog_Enconfig.FileName;
    ReadFromEnconfigInifile;
    DisplayEncatOptions;    // always before SetmemData
    SetMemData;
    g_RegIniData.IniEncodersIniFileName := EnconfigIniFileName;
    SaveRegIniFile;
  end;
end;

procedure TfrmEnconfig.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Free;
  frmEnconfig := nil;
end;

procedure TfrmEnconfig.Menu_SaveClick(Sender: TObject);
begin
  if SaveDialog_Enconfig.Execute then
  begin
    EnconfigIniFileName := SaveDialog_Enconfig.FileName;
    GetEncatOptions;        // always before GetMemData   ... sets IcomCIV
    GetMemData;
    WriteToEnconfigIniFile;
    g_RegIniData.IniEncodersIniFileName := EnconfigIniFileName;
    SaveRegIniFile;
  end;
end;

procedure TfrmEnconfig.Menu_LoadClick(Sender: TObject);
begin
  OpenDialog_Enconfig.FileName := g_RegIniData.IniEncodersIniFileName;
  if OpenDialog_Enconfig.Execute then
  begin
    EnconfigIniFileName := OpenDialog_Enconfig.FileName;
    ReadFromEnconfigInifile;
    DisplayEncatOptions;   // always before SetMemData;
    SetMemData;
    g_RegIniData.IniEncodersIniFileName := EnconfigIniFileName;
    SaveRegIniFile;
  end;
end;




procedure TfrmEnconfig.RzRB_RS232Click(Sender: TObject);
begin
 SetGrid(false);
end;

procedure TfrmEnconfig.RzRB_CIVClick(Sender: TObject);
begin
  SetGrid(true);
end;


procedure TfrmEnconfig.RzBitBtn_HelpClick(Sender: TObject);
begin
  HtmlHelp.ChmFile := ExtractFilePath(Application.EXEName) + 'xcat.chm';
  HtmlHelp.DisplayContext(6);
end;

end.
///////////////////////////////////////////////







