unit UfrmLookups;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dxExEdtr, dxTL, dxDBCtrl, dxDBGrid, dxCntner, DB, dxmdaset,
  StdCtrls, Mask, RzEdit, RzButton, RzLabel, ExtCtrls, RzPanel,
  syncobjs;

type
  TfrmLookups = class(TForm)
    RzPanel1: TRzPanel;
    RzLabel1: TRzLabel;
    RzBitBtn_ReadLookups: TRzBitBtn;
    RzBitBtn_SetLookups: TRzBitBtn;
    RzBitBtn_WriteToFile: TRzBitBtn;
    RzBitBtn_ReadFromFile: TRzBitBtn;
    RzEdit_Title: TRzEdit;
    dxMemData_Lookups: TdxMemData;
    dxDBGrid_Lookups: TdxDBGrid;
    Col_Encoder0: TdxDBGridColumn;
    Col_Encoder1: TdxDBGridColumn;
    Col_Encoder2: TdxDBGridColumn;
    Col_Encoder3: TdxDBGridColumn;
    Col_Encoder4: TdxDBGridColumn;
    Col_Encoder5: TdxDBGridColumn;
    Col_Encoder6: TdxDBGridColumn;
    Col_Encoder7: TdxDBGridColumn;
    dxMemData_LookupsEnc0: TIntegerField;
    dxMemData_LookupsEnc1: TIntegerField;
    dxMemData_LookupsEnc2: TIntegerField;
    dxMemData_LookupsEnbc3: TIntegerField;
    dxMemData_LookupsEnc4: TIntegerField;
    dxMemData_LookupsEnc5: TIntegerField;
    dxMemData_LookupsEnbc6: TWordField;
    dxMemData_LookupsEnc7: TIntegerField;
    DS_Lookups: TDataSource;
    Col_CatValue: TdxDBGridColumn;
    dxMemData_LookupsCatValue: TIntegerField;
    OpenDialog_lookups: TOpenDialog;
    SaveDialog_Lookups: TSaveDialog;
    RzLabel2: TRzLabel;
    procedure dxDBGrid_LookupsCustomDrawCell(Sender: TObject;
      ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
      AColumn: TdxTreeListColumn; ASelected, AFocused,
      ANewItemRow: Boolean; var AText: String; var AColor: TColor;
      AFont: TFont; var AAlignment: TAlignment; var ADone: Boolean);
    procedure RzBitBtn_SetLookupsClick(Sender: TObject);
    procedure RzBitBtn_ReadLookupsClick(Sender: TObject);
    procedure RzBitBtn_WriteToFileClick(Sender: TObject);
    procedure RzBitBtn_ReadFromFileClick(Sender: TObject);
  private
    CatValueFieldIndex: integer;
    Enc0Fieldindex: integer;
    Enc1Fieldindex: integer;
    Enc2Fieldindex: integer;
    Enc3Fieldindex: integer;
    Enc4Fieldindex: integer;
    Enc5Fieldindex: integer;
    Enc6Fieldindex: integer;
    Enc7Fieldindex: integer;
    LookupsDelayEvent: TEvent;
    block: array[0..128] of byte;
    procedure ZeroMemData;
    procedure SetMemData;
    function GetMemData: boolean;
    function DoSetEncatLookups: boolean;
    function DoReadEncatLookups: boolean;
  public
    procedure Initialise;
    procedure ReadEncatLookups;
    procedure SetEncatLookups;
  end;

var
  frmLookups: TfrmLookups;

implementation
uses UGlobals, UfrmMain, D2XXUnit, UUsb, UIniData;

{$R *.dfm}


procedure TfrmLookups.Initialise;
begin
  LookupsDelayEvent := TEvent.Create(0, true, false, 'xCAT USB lookups delay event');
  CatValueFieldIndex := dxDBGrid_Lookups.ColumnByFieldName('CatValue').Index;
  Enc0FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc0').Index;
  Enc1FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc1').Index;
  Enc2FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc2').Index;
  Enc3FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc3').Index;
  Enc4FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc4').Index;
  Enc5FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc5').Index;
  Enc6FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc6').Index;
  Enc7FieldIndex := dxDBGrid_Lookups.ColumnByFieldName('Enc7').Index;
  ZeroMemData;
end;


procedure TfrmLookups.ZeroMemData;
var
  i: byte;
  s: string;
  number: byte;
begin
  dxMemData_Lookups.Close;
  dxMemData_Lookups.Open;
  for i := 0 to 53 do
  begin
    with dxMemData_Lookups do
    begin
      Append;
      FieldValues['CatValue'] := i;
      FieldValues['Enc0'] := 0;
      FieldValues['Enc1'] := 0;
      FieldValues['Enc2'] := 0;
      FieldValues['Enc3'] := 0;
      FieldValues['Enc4'] := 0;
      FieldValues['Enc5'] := 0;
      FieldValues['Enc6'] := 0;
      FieldValues['Enc7'] := 0;
      Post;
    end;
  end;
  dxDBGrid_Lookups.GotoFirst;
end;


procedure TfrmLookups.SetMemData;
var
  i: byte;
  s: string;
  number: byte;
begin
  dxMemData_Lookups.Close;
  dxMemData_Lookups.Open;
  for i := 0 to 53 do
  begin
    with dxMemData_Lookups do
    begin
      Append;
      FieldValues['CatValue'] := i;
      FieldValues['Enc0'] := g_Lookups[0][i];
      FieldValues['Enc1'] := g_Lookups[1][i];
      FieldValues['Enc2'] := g_Lookups[2][i];
      FieldValues['Enc3'] := g_Lookups[3][i];
      FieldValues['Enc4'] := g_Lookups[4][i];
      FieldValues['Enc5'] := g_Lookups[5][i];
      FieldValues['Enc6'] := g_Lookups[6][i];
      FieldValues['Enc7'] := g_Lookups[7][i];
      Post;
    end;
  end;
end;


function TfrmLookups.GetMemData: boolean;
var
  e: byte;
  i: byte;
  s: string;
  number: byte;
begin
  result := true;
  for i := 0 to 53 do
  begin
    with dxMemData_Lookups do
    begin
      if Locate('CatValue',i,[loCaseInsensitive]) then
      begin
        g_Lookups[0][i] := FieldByName('Enc0').AsInteger;
        g_Lookups[1][i] := FieldByName('Enc1').AsInteger;
        g_Lookups[2][i] := FieldByName('Enc2').AsInteger;
        g_Lookups[3][i] := FieldByName('Enc3').AsInteger;
        g_Lookups[4][i] := FieldByName('Enc4').AsInteger;
        g_Lookups[5][i] := FieldByName('Enc5').AsInteger;
        g_Lookups[6][i] := FieldByName('Enc6').AsInteger;
        g_Lookups[7][i] := FieldByName('Enc7').AsInteger;
      end
      else result := false;
    end;
  end;
end;



procedure TfrmLookups.dxDBGrid_LookupsCustomDrawCell(Sender: TObject;
  ACanvas: TCanvas; ARect: TRect; ANode: TdxTreeListNode;
  AColumn: TdxTreeListColumn; ASelected, AFocused, ANewItemRow: Boolean;
  var AText: String; var AColor: TColor; AFont: TFont;
  var AAlignment: TAlignment; var ADone: Boolean);
begin

  if AColumn.Index = CatValueFieldIndex then
  begin
    AFont.Style := [fsBold];
    AFont.Color := clBlue;
  end;  
end;

procedure TfrmLookups.RzBitBtn_SetLookupsClick(Sender: TObject);
begin
  if frmMain.UsbAlive = false then
  begin
    MessageDlg('No enCAT USB connection'#10#13' (See staus bar)',mtWarning, [mbOk],0);
    exit;
  end;
  GetMemData;
  frmMain.USBstate[lookupset] := 'W';
end;


procedure TfrmLookups.SetEncatLookups;
var
  s: string;
  SetOk: boolean;
begin
  Screen.Cursor := crHourGlass;
  SetOK := DoSetEncatLookups;
  Application.ProcessMessages;
  if SetOk then
  begin
    Screen.Cursor := crDefault;
    // job done ok
  end
  else begin
    Screen.Cursor := crDefault;
    s := 'EncoderCAT lookups setting FAILED';
    MessageDlg(s,mtWarning,[mbOk],0);
  end;
end;


function TfrmLookups.DoSetEncatLookups: boolean;
var
  e: byte;
  chb: char;
begin
  result := false;
  /////////////////
  Purge_USB_Device_In;
  if not Usb.usSendString('$$$ENC_B0')
  then exit
  else begin
    StringToCharray(RzEdit_Title.Text, g_LookupInfo.nfTitle);
    move(g_LookupInfo, block, 32);
    if not Usb.usSendBlock(@block,32) then exit;
    LookupsDelayEvent.ResetEvent;
    LookupsDelayEvent.WaitFor(200);
  end;
  ////////////////////
  for e := 0 to 7 do
  begin
  chb := chr(48 + e);
    Purge_USB_Device_In;
    if not Usb.usSendString('$$$ENC_L' + chb)
    then exit
    else begin
      move(g_Lookups[e, 0], block, 108);
      if not Usb.usSendBlock(@block,108) then exit;
    end;
    LookupsDelayEvent.ResetEvent;
    LookupsDelayEvent.WaitFor(200);
  end;
  result := true;
end;
////////////////////////////////////////

procedure TfrmLookups.RzBitBtn_ReadLookupsClick(Sender: TObject);
begin
  if frmMain.UsbAlive = false then
  begin
    MessageDlg('No enCAT USB connection'#10#13' (See staus bar)',mtWarning, [mbOk],0);
    exit;
  end;
  frmMain.USBstate[lookupread] := 'W';
end;


////////////////////////////////////////

procedure TfrmLookups.ReadEncatLookups;
var
  s: string;
  ReadOk: boolean;
begin
  Screen.Cursor := crHourGlass;
  ReadOK := DoReadEncatLookups;
  Application.ProcessMessages;
  if ReadOk then
  begin
    Screen.Cursor := crDefault;
    // use rthe data
  end
  else begin
    Screen.Cursor := crDefault;
    s := 'EncoderCAT lookups read FAILED';
    MessageDlg(s,mtWarning,[mbOk],0);
  end;
end;



function TfrmLookups.DoReadEncatLookups: boolean;
var
  e: byte;
  chb: char;
begin
  result := false;
  /////////////////
  Purge_USB_Device_In;
  if not Usb.usSendString('$$$ENC_A0')
  then exit
  else begin
    LookupsDelayEvent.ResetEvent;
    LookupsDelayEvent.WaitFor(100);
    if not Usb.usReceiveBlock(@block,32) then exit;
    move(block, g_LookupInfo, 32);
    LookupsDelayEvent.ResetEvent;
    LookupsDelayEvent.WaitFor(50);
    RzEdit_Title.text := g_LookupInfo.nfTitle;
  end;
  //////////
  for e := 0 to 7 do     // 'Ecoder 8' record used for options
  begin
    chb := chr(48 + e);
    Purge_USB_Device_In;
    if not Usb.usSendString('$$$ENC_K' + chb)
    then exit
    else begin
      LookupsDelayEvent.ResetEvent;
      LookupsDelayEvent.WaitFor(50);
      if not Usb.usReceiveBlock(@block,108) then exit;
      move(block, g_Lookups[e, 0], 108);
      LookupsDelayEvent.ResetEvent;
      LookupsDelayEvent.WaitFor(20);
    end;
  end;
  SetMemData;
  result := true;
  dxDBGrid_Lookups.GotoFirst;
end;




procedure TfrmLookups.RzBitBtn_WriteToFileClick(Sender: TObject);
begin
  if SaveDialog_Lookups.Execute then
  begin
    LookupsIniFileName := SaveDialog_Lookups.FileName;
    GetMemData;
    WriteToLookupsIniFile;
    g_RegIniData.IniLookupsIniFileName := LookupsIniFileName;
    SaveRegIniFile;
  end;
end;

procedure TfrmLookups.RzBitBtn_ReadFromFileClick(Sender: TObject);
begin
  OpenDialog_Lookups.FileName := g_RegIniData.IniLookupsIniFileName;
  if OpenDialog_Lookups.Execute then
   begin
    LookupsIniFileName := OpenDialog_Lookups.FileName;
    ReadFromLookupsInifile;
    SetMemData;
    g_RegIniData.IniLookupsIniFileName := LookupsIniFileName;
    SaveRegIniFile;
  end;
  dxDBGrid_Lookups.GotoFirst;
end;

end.
