unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RzButton, RzPanel, ExtCtrls, Menus, RzStatus, syncobjs,
  UGlobals, UiniData, HHComp;

type

  TUSBjob = (status, encread, encset, lookupset, lookupread, debug);

  TfrmMain = class(TForm)
    MainMenu_Main: TMainMenu;
    Menu_File: TMenuItem;
    RzToolbar1: TRzToolbar;
    RzSpacer1: TRzSpacer;
    RzSpacer2: TRzSpacer;
    RzSpacer3: TRzSpacer;
    RzBitBtn_Debug: TRzBitBtn;
    RzStatusBar1: TRzStatusBar;
    RzStatusPane_left: TRzStatusPane;
    RzClockStatus1: TRzClockStatus;
    RzStatusPane_COM: TRzStatusPane;
    RzStatusPane_Encat: TRzStatusPane;
    Timer_Startup: TTimer;
    Timer_USBqueue: TTimer;
    Timer_USBstatus: TTimer;
    Menu_Exit: TMenuItem;
    Help1: TMenuItem;
    RzBitBtn_Enconfig: TRzBitBtn;
    WIndow1: TMenuItem;
    ile1: TMenuItem;
    Cascadde1: TMenuItem;
    HtmlHelp: TEmbeddedHtmlHelp;
    Menu_About: TMenuItem;
    Menu_Help: TMenuItem;
    RzSpacer4: TRzSpacer;
    RzBitBtn1: TRzBitBtn;
    menu_update: TMenuItem;
    procedure RzBitBtn_DebugClick(Sender: TObject);
    procedure Timer_StartupTimer(Sender: TObject);
    procedure Timer_USBstatusTimer(Sender: TObject);
    procedure Timer_USBqueueTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Menu_ExitClick(Sender: TObject);
    procedure RzBitBtn_EnconfigClick(Sender: TObject);
    procedure ile1Click(Sender: TObject);
    procedure Cascadde1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Menu_AboutClick(Sender: TObject);
    procedure Menu_HelpClick(Sender: TObject);
    procedure RzBitBtn1Click(Sender: TObject);
    procedure menu_updateClick(Sender: TObject);
  private
    NeedToGetVersion: boolean;
    MainDelayEvent: TEvent;
    procedure CloseUsb;
    procedure GetEncatStatus;
    procedure ClearUsbQueue;
  public
    UsbAlive: boolean;
    USBjob: TUSBjob;
    Terminating: boolean;
    USBstate: array[status..debug] of char;
  end;

var
  frmMain: TfrmMain;

implementation

uses UfrmDebug, UUsb, D2XXUnit, UfrmEnconfig, About, UfrmLookups,
  UfrmUpdate;

{$R *.dfm}

procedure TfrmMain.RzBitBtn_DebugClick(Sender: TObject);
begin
  if frmDebug = nil then
  begin
    frmDebug := TfrmDebug.Create(self);
    frmDebug.Initialise;
  end;
  frmDebug.Show;
end;

procedure TfrmMain.GetEncatStatus;
var
  Encatversion: string;
begin
  with Usb do
  begin
    if usTestStatus then
    begin
      UsbAlive := true;
      RzStatusPane_left.caption := 'USB: ' + usDeviceDescription
                                             + '  s/n: ' + usDeviceSerialNo;
    end
    else begin
      UsbAlive := false;
      Encatversion := '';
      NeedToGetVersion := true;
      RzStatusPane_left.caption := 'USB: ' + 'EncoderCAT not detected';
    end;
    if UsbAlive then
    begin
      g_UsbReady := true;
      if NeedToGetVersion then
      begin
        Encatversion := usgetEncatversion;
        if Encatversion <> '' then
        begin
          with RzStatusPane_Encat do
          begin
            Font.Color := clBlack;
            Caption := 'EncoderCAT v' + Encatversion +  ' ready';
            NeedToGetVersion := false
          end;
        end;
      end;
    end
    else begin
      NeedToGetVersion := true;
      ClearUsbQueue;
      g_UsbReady := false;
      RzStatusPane_Encat.Caption := '';
    end;
  end;
end;


procedure TfrmMain.ClearUsbQueue;
var
  job: TUSBjob;
begin
  for job := status to debug do USBstate[job] := 'X';
end;


procedure TfrmMain.CloseUsb;
begin
  RzStatusPane_left.caption := 'USB: ' + 'Main window USB connection closed';
  Application.ProcessMessages;
  Usb.usCloseConnection;
end;


procedure TfrmMain.Timer_StartupTimer(Sender: TObject);
var
  TimeString: string;
begin
  LoadRegIniFile;
  FT_Enable_Error_Report := False; // Turn off error dialog
  Timer_Startup.enabled := false;
  g_TempPath := ExtractFilePath(Application.ExeName) + 'Temp';
  if not DirectoryExists(g_TempPath) then CreateDir(g_TempPath);
  {File names are made unique to terminal by using application startup time hhmmsszzz
   where zzz is milliseconds.  }
  TimeString := FormatDateTime('hhmmsszzz',Now);
  g_TextFilePath := g_TempPath + '\' + 'DATA' + '_' + TimeString + '.RTF';
  Timer_USBstatus.enabled := true;
  ////  Auto jump to Encoder configuration   ... until Encat has more functions
  if frmEnconfig = nil then
  begin
    frmEnconfig := TfrmEnconfig.Create(self);
    frmEnconfig.Initialise;
  end;
  frmEnconfig.Show;
end;

procedure TfrmMain.Timer_USBstatusTimer(Sender: TObject);
begin
  if terminating then exit;
  USBstate[status] := 'W';
end;

procedure TfrmMain.Timer_USBqueueTimer(Sender: TObject);
var
  FirstJob: TUSBjob;
  js: char;
  done: boolean;
begin
  if not Usb.usDeviceOpenAndOk then USBjob := status;
  Timer_USBqueue.enabled := false;
  FirstJob := USBjob;
  done := false;
  repeat
    js := USBstate[USBjob];
    if js = 'W' then
    begin
      USBstate[USBjob] := 'X';
      done := true;
      case USBjob of
        status:         GetEncatStatus;
        debug:          if frmDebug <> nil then frmDebug.RequestDebugData;
        encread:        if frmEnconfig <> nil then frmEnconfig.ReadEncatEncoders;
        encset:         if frmEnconfig <> nil then frmEnconfig.SetEncatEncoders;
        lookupset:      if frmLookups <> nil then frmLookups.SetEncatLookups;
        lookupread:     if frmLookups <> nil then frmLookups.ReadEncatLookups;
       end; { case }
    end;
    inc(USBjob);
    if USBjob > debug then USBjob := status;
  until done OR (USBjob = FirstJob);
  Timer_USBqueue.enabled := true;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Terminating := false;
  Usb := TUsb.Create;
//  Usb.usBusy := false;
  USBjob := status;
  //Caption := ' ENCAT';
  HtmlHelp.ChmFile := ExtractFilePath(Application.ExeName) + 'xCAT.chm';
  EnsureIniFileIsRegistry;
  LoadMainCoordinates;
  with g_RegIniData do
  begin
    top := IniMainFormTop;
    left := IniMainFormLeft;
    height := IniMainFormHeight;
    width := IniMainFormWidth;
  end;
  LoadDebugCoordinates;
  LoadRegIniFile;
//  ErrorLogInit;
  LoadDebugIniData;
  ClearUsbQueue;
  NeedToGetVersion := true;
  MainDelayEvent := TEvent.Create(0, true, false, 'EncoderCAT frmMain delay event');
  Application.ProcessMessages;
  Timer_Startup.Enabled := true;
end;



procedure TfrmMain.Menu_ExitClick(Sender: TObject);
begin
  Terminating := true;
  with g_RegIniData do
  begin
    IniMainFormLeft := left;
    IniMainFormTop := top;
    IniMainFormWidth := width;
    InimainFormHeight := height;
    SaveMainCoordinates;
  end;
  if frmEnconfig <> nil then frmEnconfig.Close;
  if frmDebug <> nil then frmDebug.Close;
  Close;
end;

procedure TfrmMain.RzBitBtn_EnconfigClick(Sender: TObject);
begin
  if frmEnconfig = nil then
  begin
    frmEnconfig := TfrmEnconfig.Create(self);
    frmEnconfig.Initialise;
  end;
  frmEnconfig.Show;
end;

procedure TfrmMain.ile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TfrmMain.Cascadde1Click(Sender: TObject);
begin
  Cascade
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Terminating := true;
  with g_RegIniData do
  begin
    IniMainFormLeft := left;
    IniMainFormTop := top;
    IniMainFormWidth := width;
    InimainFormHeight := height;
    SaveMainCoordinates;
  end;
  if frmEnconfig <> nil then frmEnconfig.Close;
  if frmDebug <> nil then frmDebug.Close;
end;

procedure TfrmMain.Menu_AboutClick(Sender: TObject);
begin
  AboutBox.Initialise;
  AboutBox.ShowModal;
end;

procedure TfrmMain.Menu_HelpClick(Sender: TObject);
begin
  HtmlHelp.ChmFile := ExtractFilePath(Application.EXEName) + 'xcat.chm';
  HtmlHelp.DisplayContext(1);
end;

procedure TfrmMain.RzBitBtn1Click(Sender: TObject);
begin
  if frmLookups = nil then
  begin
    frmLookups:= TfrmLookups.Create(self);
    frmLookups.Initialise;
  end;
  frmLookups.Show;
end;

procedure TfrmMain.menu_updateClick(Sender: TObject);
begin
  if frmUpdate = nil then
  begin
    frmUpdate := TfrmUpdate.Create(self);
    frmUpdate.Initialise(false);
  end;
  frmUpdate.Show;
end;

end.


