program xcat;

uses
  Forms,
  Windows,
  SysUtils,
  Dialogs,
  UfrmMain in 'UfrmMain.pas' {frmMain},
  UIniData in 'UIniData.pas',
  UfrmDebug in 'UfrmDebug.pas' {frmDebug},
  UGlobals in 'UGlobals.pas',
  UUsb in 'UUsb.pas',
  D2XXUnit in 'D2XXUnit.pas',
  UfrmSelectEncat in 'UfrmSelectEncat.pas' {frmSelectEncat},
  UfrmEnconfig in 'UfrmEnconfig.pas' {frmEnconfig},
  About in 'About.pas' {AboutBox},
  UfrmLookups in 'UfrmLookups.pas' {frmLookups},
  UfrmUpdate in 'UfrmUpdate.pas' {frmUpdate},
  UfrmUpdateCheck in 'UfrmUpdateCheck.pas' {frmUpdateCheck};

{$R *.res}

const
  AllowedInstances = 1;

var
  MyAppName   : Array[0..255] of Char;
  MyClassName : Array[0..255] of Char;
  NumFound    : Integer;
  LastFound   : HWnd;
  MyPopup     : HWnd;
  s: string;

function LookAtAllWindows(Handle: HWND; Temp: LongInt): BOOL; stdcall;
var
  WindowName : Array[0..255] of Char;
  ClassName  : Array[0..255] of Char;
begin
  // Go get the windows class name
  if GetClassName(Handle,ClassName,SizeOf(ClassName)) > 0 then
    // Is the window class the same?
    if StrComp(ClassName,'TfrmMain') = 0 then
      // Get its window caption
      if GetWindowText(Handle,WindowName,SizeOf(WindowName)) > 0 then
        // Does this have the same window title?
        s := WindowName;
        if Copy(s,2,4) = 'xCAT' then
          begin
            inc(NumFound);
            // Are the handles different?
            if Handle <> Application.Handle then
              // Save it so we can bring it to the top later.
              LastFound := Handle;
          end;
end;


begin
  g_Xcatversion := 'verion 1.101';
  NumFound := 0; LastFound := 0;
  // First, determine what this application's name is
  GetWindowText(Application.Handle,MyAppName,SizeOf(MyAppName));
  // Now determine the class name for this application
  GetClassName(Application.Handle,MyClassName,SizeOf(MyClassName));
  // Now count how many others out there are Delphi apps with this title
  EnumWindows(@LookAtAllWindows,0);
  if NumFound < AllowedInstances then
  begin
    Application.Initialize;
    Application.Title := 'xCAT';
    Application.CreateForm(TfrmMain, frmMain);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.Run;
  end
  else MessageDlg('Another instance of xCAT is already running',mtWarning,[mbAbort],0);
end.


